<?php
  require('ref.php');

  $step = dependencies(intval($_POST['step']));
  unset($_POST['step']);
  $title = 'P3P Generator';
  if($step == 18) $title .= ' - Done!';
  else if($step > 0) $title .= " - Step $step";
?>
<html>
<head>
  <title><?=$title?></title>
</head>
<body>
<h1><?=$title?></h1>
<form method="post" name="theform" action="index.php">
  <?php
    passalong();
    call_user_func('step'.$step);
    if($step) echo "<input type=\"button\" onclick=\"prev()\" value=\"Previous\"/>\n";
    $step++;
    if($step < 18)
    {
      echo "<input type=\"submit\" value=\"Step $step\" />\n";
    }
    else if($step == 18)
    {
      echo "<input type=\"submit\" value=\"Generate!\" />\n";
    }
    echo "<input id=\"step\" type=\"hidden\" name=\"step\" value=\"$step\" />\n";
  ?>
</form>
<script type="text/javascript">
  function prev()
  {
    document.theform.step.value = <?=$step?> - 2;
    document.theform.submit();
  }
</script>
</body>
</html>

<?php

  function dependencies($step)
  {
    if(!isset($_POST['reference_method']))
    {
      $step = min($step, 1);
    }
    else if(!isset($_POST['reference_path']) || !isset($_POST['reference_name']))
    {
      $step = min($step, 2);
    }
    else if(!isset($_POST['privacy_zones']) || intval($_POST['privacy_zones']) < 1)
    {
      $step = min($step, 3);
    }
    else
    {
      for($i = 1; $i <= $_POST['privacy_zones']; $i++)
      {
        if(!isset($_POST['policy'][$i]['name']) || !isset($_POST['policy'][$i]['include']) || !isset($_POST['policy'][$i]['exclude']))
        {
          $step = min($step, 4);
        }
        else if(!isset($_POST['policy'][$i]['cookie_include']) || !isset($_POST['policy'][$i]['cookie_exclude']) || !isset($_POST['policy'][$i]['methods']))
        {
          $step = min($step, 5);
        }
        else
        {
          global $organization;
          foreach($organization as $key=>$description)
          {
            if(!isset($_POST['policy'][$i]['organization'][$key]))
              $step = min($step, 6);
          }

          if(!isset($_POST['policy'][$i]['opt_in_out_url']) || !isset($_POST['policy'][$i]['access']))
          {
            $step = min($step, 7);
          }
          else if(!isset($_POST['policy'][$i]['dispute']['resolution']) || !isset($_POST['policy'][$i]['dispute']['url']) ||
                  !isset($_POST['policy'][$i]['dispute']['remedy']) || !isset($_POST['policy'][$i]['dispute']['description']))
          {
            $step = min($step, 8);
          }
          else if(!isset($_POST['policy'][$i]['consequence']))
          {
            $step = min($step, 9);
          }
          else if(!isset($_POST['policy'][$i]['retention']))
          {
            $step = min($step, 12);
          }
        }
      }
    }
    return $step;
  }

  function step0()
  {
    ?><h1>P3P Generator</h1>
    <p>Please note: This is generator represents the author's best guess at P3P generation. While I am sure that there are errors,
    the result does validate correctly with the <a href="http://www.w3.org/P3P/validator.html">P3P Validator</a>. Please familiarize
    yourself with the <a href="http://www.w3.org/TR/P3P/">P3P Specification</a>.</p>
    <p><b>Note: Most of the text and descriptions were copied verbatim from the P3P specification.</b></p>
    <p><a href="p3p-gen.tar.gz">source</a></p>
    <p><i><a href="mailto:david@eder.us">David Eder</a></i></p>
    <?php
  }

  function step1()
  {
    global $reference_methods;
    if(!isset($_POST['reference_method'])) $_POST['reference_method'] = 'well-known';

    ?><h2>Step 1 - Reference File Location Method:</h2>
    <p>There are three methods for directing the user-agent to your reference file:</p>
    <ol>
      <?php
        foreach($reference_methods as $key=>$description)
        {
          echo "<li><input type=\"radio\" name=\"reference_method\" value=\"$key\"";
          if($_POST['reference_method'] == $key) echo ' checked="checked"';
          echo "/>$description</li>\n";
        }
      ?>
    </ol>
    <?php
  }

  function step2()
  {
    if(!isset($_POST['reference_path'])) $_POST['reference_path'] = '/w3c/';
    if(!isset($_POST['reference_name'])) $_POST['reference_name'] = 'p3p.xml';

    echo "<h2>Step 2 - Reference File Location:</h2>\n";
    if($_POST['reference_method'] == 'well-known')
    {
      ?><h3>The reference file will be located at /w3c/p3p.xml</h3>
        <input type="hidden" name="reference_path" value="/w3c/" />
        <input type="hidden" name="reference_name" value="p3p.xml" />
      <?php
    }
    else
    {
      ?>
      <table>
        <tr><td>Reference File Path</td><td><input type="text" name="reference_path" value="<?=$_POST['reference_path']?>" /></td></tr>
        <tr><td>Reference File Name</td><td><input type="text" name="reference_name" value="<?=$_POST['reference_name']?>" /></td></tr>
      </table>
      <?php
    }
  }

  function step3()
  {
    if(!isset($_POST['privacy_zones'])) $_POST['privacy_zones'] = 1;
    ?>
    <h2>Step 3 - Number of Privacy Zones:</h2>
    How many Privacy Zones?
    <input type="text" name="privacy_zones" size="2" value="<?=$_POST['privacy_zones']?>"/><br />
    <?php
  }

  function step4()
  {
    ?><h2>Step 4 - Files/Folders to Include/Exclude:</h2>
    <blockquote>
      <b>Name</b> refers to the name of the policy.<br /><br />
      <b>Files/Folders</b> refers to local files and folders covered by this policy. The wildcard character is '*'.<br /><br />
      <blockquote>
        <i>Example:</i><br /><br />
        <table border="1" cellspacing="0" cellpadding="6" width="400">
          <tr><th width="200">Include</th><th width="200">Exclude</th></tr>
          <tr>
            <td valign="top">/*</td>
            <td valign="top">/store/*<br>contact.html</td>
          </tr>
        </table><br>
        This example includes the whole site, except the <b>/store</b> folder and <b>contact.html</b>.
      </blockquote>
    </blockquote>
    <?php
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr>\n";
      echo "<h3>Policy $i</h3>\n";
      echo "<table>\n";
      echo "  <tr><td>Name:</td><td colspan=\"2\"><input type=\"text\" name=\"policy[$i][name]\" value=\"{$_POST['policy'][$i]['name']}\"/></td></tr>\n";
      echo "  <tr><td> &nbsp; </td><th>Include</th><th>Exclude</th></tr>\n";
      echo "  <tr>\n";
      echo "    <td>Files/Folders:</td><td><textarea rows=5 cols=20 name=\"policy[$i][include]\">{$_POST['policy'][$i]['include']}</textarea></td>\n";
      echo "    <td><textarea rows=\"5\" cols=\"20\" name=\"policy[$i][exclude]\">{$_POST['policy'][$i]['exclude']}</textarea></td>\n";
      echo "  </tr>\n";
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step5()
  {
    global $http_methods;
    ?><h2>Step 5 - Cookies and Methods to Include/Exclude:</h2>
    <blockquote>
      <b>Cookiess</b> refers to HTTP cookies covered by this policy. Cookies have three parts:
      <ol>
        <li><b>Name</b> - Match the name portion of the cookie.</li>
        <li><b>Value</b> - Match the value portion of the cookie.</li>
        <li><b>Domain</b> - Match the domain portion of the cookie.</li>
        <li><b>Path</b> - Match the path portion of the cookie.</li>
      </ol>
      The wildcard character is '*'.<br /><br />
      <blockquote>
        <i>Example:</i><br /><br />
        <table border="1" cellspacing="0" cellpadding="6" width="400">
          <tr><th width="200">Include</th><th width="200">Exclude</th></tr>
          <tr>
            <td valign="top">* * * /</td>
            <td valign="top" nowrap="nowrap">user-id * .mydomain.com /<br />password * * /</td>
          </tr>
        </table><br />
        This example makes all cookies available to any domain with any path, except <b>user-id</b> and <b>password</b>.
      </blockquote><br />
    </blockquote>
    <?php
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      if(!isset($_POST['policy'][$i]['cookie_include'])) $_POST['policy'][$i]['cookie_include'] = '* * * /';
      if(!isset($_POST['policy'][$i]['cookie_exclude'])) $_POST['policy'][$i]['cookie_exclude'] = '';
      if(!isset($_POST['policy'][$i]['methods'])) $_POST['policy'][$i]['methods'] = $http_methods;

      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      echo "<table>\n";
      echo "  <tr><td> &nbsp; </td><th>Include</th><th>Exclude</th></tr>\n";
      echo "  <tr>\n";
      echo "    <td valign=\"top\">Cookies:</td><td><textarea rows=\"5\" cols=\"20\" name=\"policy[$i][cookie_include]\">{$_POST['policy'][$i]['cookie_include']}</textarea></td>\n";
      echo "    <td><textarea rows=\"5\" cols=\"20\" name=\"policy[$i][cookie_exclude]\">{$_POST['policy'][$i]['cookie_exclude']}</textarea></td>\n";
      echo "  </tr>\n";
      echo "  <tr>\n";
      echo "    <td valign=\"top\">Methods:</td><td colspan=\"2\">";
      foreach($http_methods as $method)
      {
        echo "<input type=\"checkbox\" name=\"policy[$i][methods][$method]\" value=\"$method\"";
        if($_POST['policy'][$i]['methods'][$method] == $method) echo ' checked="checked"';
        echo "/>$method<br />\n";
      }
      echo "</td></tr></table>\n";
      echo "  </tr>\n";
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step6()
  {
    global $organization;
    ?><h2>Step 6 - Contact Information:</h2>
    <blockquote>
      This is the contact information for the organization responsible for this privacy policy.
    </blockquote>
    <?php
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      echo "<table>\n";
      foreach($organization as $key=>$description)
        echo "<tr><td>$description:</td><td><input type=\"text\" name=\"policy[$i][organization][$key]\" value=\"{$_POST['policy'][$i]['organization'][$key]}\"/></td></tr>\n";
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step7()
  {
    global $access;
    echo "<h2>Step 7 - Access Information:</h2>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      if(!isset($_POST['policy'][$i]['opt_in_out_url'])) $_POST['policy'][$i]['opt_in_out_url'] = 'http://';
      if(!isset($_POST['policy'][$i]['access'])) $_POST['policy'][$i]['access'] = 'noident';

      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      echo "<table>\n";
      echo "<tr><td nowrap=\"nowrap\">Opt-in/Opt-out URL:</td><td colspan=\"2\"><input type=\"text\" name=\"policy[$i][opt_in_out_url]\" value=\"{$_POST['policy'][$i]['opt_in_out_url']}\"/></td></tr>\n";
      echo "<tr><td valign=\"top\" nowrap=\"nowrap\">Updateable Data:</td>";
      $first = 1;
      foreach($access as $key=>$description)
      {
        if(!$first) echo "<tr><td>&nbsp;</td>";
        echo "<td valign=\"top\"><input type=\"radio\" name=\"policy[$i][access]\" value=\"$key\"";
        if($_POST['policy'][$i]['access'] == $key) echo ' checked="checked"';
        echo "/></td><td>$description</tr>\n";
        $first = 0;
      }
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step8()
  {
    global $disputes, $remedies;
    echo "<h2>Step 8 - Disputes Information:</h2>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      if(!isset($_POST['policy'][$i]['dispute']['resolution'])) $_POST['policy'][$i]['dispute']['resolution'] = 'service';
      if(!isset($_POST['policy'][$i]['dispute']['url'])) $_POST['policy'][$i]['dispute']['url'] = 'http://';
      if(!isset($_POST['policy'][$i]['dispute']['remedy'])) $_POST['policy'][$i]['dispute']['remedy'] = 'correct';
      if(!isset($_POST['policy'][$i]['dispute']['description'])) $_POST['policy'][$i]['dispute']['description'] = '';

      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      echo "<table>\n";
      echo "<tr><td valign=\"top\" nowrap=\"nowrap\">Resolution Type:</td>";
      $first = 1;
      foreach($disputes as $key=>$description)
      {
        if(!$first) echo "<tr><td>&nbsp;</td>";
        echo "<td valign=\"top\"><input type=\"radio\" name=\"policy[$i][dispute][resolution]\" value=\"$key\"";
        if($_POST['policy'][$i]['dispute']['resolution'] == $key) echo ' checked="checked"';
        echo "/></td><td>$description</td></tr>\n";
        $first = 0;
      }
      echo "</td></tr>\n";
      echo "<tr><td>URL:</td><td colspan=\"2\"><input type=\"text\" name=\"policy[$i][dispute][url]\" value=\"{$_POST['policy'][$i]['dispute']['url']}\"/></td></tr>\n";
      echo "<tr><td valign=\"top\">Remedy Type:</td>";
      $first = 1;
      foreach($remedies as $key=>$description)
      {
        if(!$first) echo "<tr><td>&nbsp;</td>";
        echo "<td valign=\"top\"><input type=\"radio\" name=\"policy[$i][dispute][remedy]\" value=\"$key\"";
        if($_POST['policy'][$i]['dispute']['remedy'] == $key) echo ' checked="checked"';
        echo "/></td><td>$description</td></tr>\n";
        $first = 0;
      }
      echo "</td></tr>\n";
      echo "<tr><td valign=\"top\">Description</td><td colspan=\"2\"><textarea name=\"policy[$i][dispute][description]\" rows=\"10\" cols=\"50\">{$_POST['policy'][$i]['dispute']['description']}</textarea></td></tr>\n";
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step9()
  {
    ?><h2>Step 9 - Consequence Information:</h2>
    <blockquote>
      <p><b>How is the data used?</b> - Explain why the suggested practice may be valuable in a particular instance even if
      the user would not normally allow the practice.</p>
      <p><b>Is the data non-identifiable?</b> - There is no data or no identifiable data collected. Data  is seen as
      non-identifiable in the sense of the present specification, if there is no reasonable way for the entity or a third
      party to attach the collected data to the identity of natural person.</p>
    </blockquote>
    <?php
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      echo "<table>\n";
      echo "<tr><td valign=\"top\">How is the data used?</td><td><textarea name=\"policy[$i][consequence]\" rows=\"10\" cols=\"50\">{$_POST['policy'][$i]['consequence']}</textarea></td></tr>\n";
      echo "<tr><td>Is the data non-identifiable?</td><td><input type=\"checkbox\" name=\"policy[$i][non_identifiable]\" value=\"YES\"";
      if($_POST['policy'][$i]['non_identifiable'] == 'YES') echo ' checked="checked"';
      echo "/></td></tr>\n";
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step10()
  {
    global $purpose, $required;
    echo "<h2>Step 10 - Purpose of Information:</h2>\n";
    echo "<blockquote>\n";
    foreach($purpose as $key=>$description)
      echo "<p>$description</p>\n";
    foreach($required as $key=>$description)
      echo "<p><b>$key:</b> $description</p>\n";
    echo "</blockquote>\n";

    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr />\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      echo "<table>\n";

      foreach($purpose as $key=>$description)
      {
        echo "<tr><td><input type=\"checkbox\" value=\"YES\" name=\"policy[$i][purpose][$key]\"";
        if($_POST['policy'][$i]['purpose'][$key] == 'YES') echo ' checked="checked"';
        echo "/></td>\n";
        $caption = strip_tags(substr($description, 0, strpos($description, ':')));
        echo "<td>$caption</td>\n";
        echo "<td><select name=\"policy[$i][purpose][{$key}_required]\">\n";
        foreach($required as $k=>$v)
        {
          echo "<option value=\"$k\"";
          if($_POST['policy'][$i]['purpose']["{$key}_required"] == $k) echo ' selected="selected"';
          echo ">$k</option>\n";
        }
        echo "</select></td></tr>\n";
      }
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step11()
  {
    global $recipient;
    echo "<h2>Step 11 - Recipients of Information:</h2>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      echo "<table>\n";
      foreach($recipient as $key=>$description)
      {
        echo "<tr><td valign=\"top\"><input type=\"checkbox\" value=\"YES\" name=\"policy[$i][recipient][$key]\"";
        if($_POST['policy'][$i]['recipient'][$key] == 'YES') echo ' checked="checked"';
        echo "/></td>\n";
        echo "<td>$description</td></tr>\n";
      }
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step12()
  {
    global $retention;
    echo "<h2>Step 12 - Retention of Information:</h2>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      if(!isset($_POST['policy'][$i]['retention'])) $_POST['policy'][$i]['retention'] = 'no-retention';
      echo "<hr />\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      echo "<table>\n";
      foreach($retention as $key=>$description)
      {
        echo "<tr><td valign=\"top\"><input type=\"radio\" value=\"$key\" name=\"policy[$i][retention]\"";
        if($_POST['policy'][$i]['retention'] == $key) echo ' checked="checked"';
        echo "/></td>\n";
        echo "<td>$description</td></tr>\n";
      }
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step13()
  {
    global $base;
    echo "<h2>Step 13 - Dynamic Data Collection:</h2>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      walk($base['dynamic'], 'dynamic', $i);
    }
    echo "<hr />\n";
  }

  function step14()
  {
    global $base;
    echo "<h2>Step 14 - User Data Collection:</h2>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      walk($base['user'], 'user', $i);
    }
    echo "<hr />\n";
  }

  function step15()
  {
    global $base;
    echo "<h2>Step 15 - Third Party Data Collection:</h2>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      walk($base['thirdparty'], 'thirdparty', $i);
    }
    echo "<hr />\n";
  }

  function step16()
  {
    global $base;
    echo "<h2>Step 16 - Business Data Collection:</h2>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      walk($base['business'], 'business', $i);
    }
    echo "<hr />\n";
  }

  function step17()
  {
    global $category;
    echo "<h2>Step 17 - Categories of Data Collection:</h2>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      echo "<hr>\n";
      echo "<h3>Policy $i - {$_POST['policy'][$i]['name']}</h3>\n";
      echo "<table>\n";
      foreach($category as $key=>$description)
      {
        echo "<td valign=\"top\"><input type=\"checkbox\" name=\"policy[$i][category][$key]\" value=\"YES\"";
        if($_POST['policy'][$i]['category'][$key] == 'YES') echo ' checked="checked"';
        echo "/></td><td>$description</td></tr>\n";
      }
      echo "</table>\n";
    }
    echo "<hr />\n";
  }

  function step18()
  {
    $file['headers.txt'] = generate_headers();
    $file[trim($_POST['reference_path'])] = generate_reference_file();
    foreach($_POST['policy'] as $i=>$p)
    {
      $policy = str_replace(' ', '_', $_POST['policy'][$i]['name']);
      $policy_file = $policy . '.xml';
      $policy_disc = $policy . '.html';
      $file[$policy_file] = generate_policy_file($i);
      $file[$policy_disc] = generate_human_policy_file($i);
    }

    echo '<pre>';
    $trans = get_html_translation_table(HTML_ENTITIES);
    while(list($filename, $content) = each($file))
    {
      $dashes = "";
      for($i = 0; $i < 30 - strlen($filename); $i++) $dashes .= "-";
      echo "$dashes start $filename $dashes<br />\n";
      echo strtr($content, $trans);
      echo "$dashes  end  $filename $dashes<br />\n";
    }
    echo '</pre>';
  }

  function generate_headers()
  {
    global $compact_tags;

    $reference_path = trim($_POST['reference_path']);
    if(substr($reference_path, strlen($reference_path) -1) != "/") $reference_path .= "/";
    $reference_name = $_POST['reference_name'];

    $ret .= "LINK tag:\n";
    $ret .= "<link rel=\"P3Pv1\" href=\"$reference_path$reference_name\" />\n\n";

    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      $ret .= "{$_POST['policy'][$i]['name']} HTTP header:\n";
      $compact = $compact_tags['access'][$_POST['policy'][$i]['access']];
      if(isset($_POST['policy'][$i]['dispute']['resolution']))
        $compact .= ' ' . $compact_tags['dispute']['*'];
      $compact .= ' ' . $compact_tags['remedy'][$_POST['policy'][$i]['dispute']['remedy']];
      if(isset($_POST['policy'][$i]['non_identifiable']))
        $compact .= ' ' . $compact_tags['non_identifiable']['*'];
      else
      {
        foreach($_POST['policy'][$i]['purpose'] as $key=>$yes) if($yes == 'YES')
        {
          $req = $_POST['policy'][$i]['purpose']["{$key}_required"];
          if($req == '') $req = 'always';
          $compact .= ' ' . $compact_tags['purpose'][$key] . $compact_tags['required'][$req];
        }
      }
      foreach($_POST['policy'][$i]['recipient'] as $key=>$yes) if($yes == 'YES')
      {
        $compact .= ' ' . $compact_tags['recipient'][$key];
      }
      $compact .= ' ' . $compact_tags['retention'][$_POST['policy'][$i]['retention']];
      foreach($_POST['policy'][$i]['category'] as $key=>$yes) if($yes == 'YES')
      {
        $compact .= ' ' . $compact_tags['category'][$key];
      }

      $compact = trim($compact);
      $ret .= "P3P: policyref=\"$reference_path$reference_name\", CP=\"$compact\"\n\n";
    }
    return $ret;
  }

  function generate_reference_file()
  {
    $reference_path = trim($_POST['reference_path']);
    $ret =  "<META xmlns=\"http://www.w3.org/2002/01/P3Pv1\" xml:lang=\"en\">\n";
    $ret .= "  <POLICY-REFERENCES>\n";
    for($i = 1; $i <= $_POST['privacy_zones']; $i++)
    {
      $policy = str_replace(' ', '_', $_POST['policy'][$i]['name']);
      $policy_file = $policy . '.xml';
      $ret .= "    <POLICY-REF about=\"{$reference_path}{$policy_file}#{$policy}\">\n";

      // INCLUDE & EXCLUDE
      $vals = split("\n", $_POST['policy'][$i]['include']);
      for($j = 0; $j < sizeof($vals); $j++)
      {
        if(trim($vals[$j]) != '')
          $ret .= '      <INCLUDE>'.trim($vals[$j])."</INCLUDE>\n";
      }
      $vals = split("\n", $_POST['policy'][$i]['exclude']);
      for($j = 0; $j < sizeof($vals); $j++)
      {
        if(trim($vals[$j]) != '')
          $ret .= '      <EXCLUDE>'.trim($vals[$j])."</EXCLUDE>\n";
      }

      // COOKIE-INCLUDE & COOKIE-EXCLUDE
      $vals = split("\n", $_POST['policy'][$i]['cookie_include']);
      for($j = 0; $j < sizeof($vals); $j++)
      {
        if(trim($vals[$j]) != '')
        {
          $v = split(' ', $vals[$j]);
          $ret .= "      <COOKIE-INCLUDE name=\"$v[0]\" value=\"$v[1]\" domain=\"$v[2]\" path=\"$v[3]\"/>\n";
        }
      }
      $vals = split("\n", $_POST['policy'][$i]['cookie_exclude']);
      for($j = 0; $j < sizeof($vals); $j++)
      {
        if(trim($vals[$j]) != '')
        {
          $v = split(' ', $vals[$j]);
          $ret .= "      <COOKIE-EXCLUDE name=\"$v[0]\" value=\"$v[1]\" domain=\"$v[2]\" path=\"$v[3]\"/>\n";
        }
      }

      // METHOD
      foreach($_POST['policy'][$i]['methods'] as $method)
        $ret .= "      <METHOD>$method</METHOD>\n";

      $ret .= "    </POLICY-REF>\n";
    }
    $ret .= "  </POLICY-REFERENCES>\n";
    $ret .= "</META>\n";
    return $ret;
  }

  function generate_policy_file($i)
  {
    $reference_path = trim($_POST['reference_path']);
    $policy = str_replace(' ', '_', $_POST['policy'][$i]['name']);
    $policy_disc = $policy . '.html';

    $ret = "<POLICIES xmlns=\"http://www.w3.org/2002/01/P3Pv1\">\n";
    $ret .= "  <POLICY discuri=\"$reference_path$policy_disc\" name=\"$policy\"";
    if(trim($_POST['policy'][$i]['opt_in_out_url']) != '' && trim($_POST['policy'][$i]['opt_in_out_url']) != 'http://')
      $ret .= " opturi=\"{$_POST['policy'][$i]['opt_in_out_url']}\"";
    $ret .= ">\n";
    $ret .= "    <ENTITY>\n";
    $ret .= "      <DATA-GROUP>\n";
    $ret .= "        <DATA ref=\"#business.name\">{$_POST['policy'][$i]['organization']['name']}</DATA>\n";
    $ret .= "        <DATA ref=\"#business.contact-info.online.email\">{$_POST['policy'][$i]['organization']['email']}</DATA>\n";
    $ret .= "        <DATA ref=\"#business.contact-info.online.uri\">{$_POST['policy'][$i]['organization']['website']}</DATA>\n";
    $ret .= "        <DATA ref=\"#business.contact-info.telecom.telephone.number\">{$_POST['policy'][$i]['organization']['telephone']}</DATA>\n";
    $ret .= "        <DATA ref=\"#business.contact-info.postal.street\">{$_POST['policy'][$i]['organization']['address']}</DATA>\n";
    $ret .= "        <DATA ref=\"#business.contact-info.postal.city\">{$_POST['policy'][$i]['organization']['city']}</DATA>\n";
    $ret .= "        <DATA ref=\"#business.contact-info.postal.stateprov\">{$_POST['policy'][$i]['organization']['stateprov']}</DATA>\n";
    $ret .= "        <DATA ref=\"#business.contact-info.postal.postalcode\">{$_POST['policy'][$i]['organization']['postalcode']}</DATA>\n";
    $ret .= "      </DATA-GROUP>\n";
    $ret .= "    </ENTITY>\n";
    $ret .= "    <ACCESS><{$_POST['policy'][$i]['access']}/></ACCESS>\n";
    $ret .= "    <DISPUTES-GROUP>\n";
    $ret .= "      <DISPUTES resolution-type=\"{$_POST['policy'][$i]['dispute']['resolution']}\" service=\"{$_POST['policy'][$i]['dispute']['url']}\" short-description=\"Disputes\">\n";
    $ret .= "        <LONG-DESCRIPTION>{$_POST['policy'][$i]['dispute']['description']}</LONG-DESCRIPTION>\n";
    $ret .= "        <REMEDIES><{$_POST['policy'][$i]['dispute']['remedy']}/></REMEDIES>\n";
    $ret .= "      </DISPUTES>\n";
    $ret .= "    </DISPUTES-GROUP>\n";
    $ret .= "    <STATEMENT>\n";
    $ret .= "      <CONSEQUENCE>{$_POST['policy'][$i]['consequence']}</CONSEQUENCE>\n";
    if($_POST['policy'][$i]['non_identifiable'] == 'YES')
      $ret .= "      <NON-IDENTIFIABLE/>\n";

    $ret .= "      <PURPOSE>\n";
    foreach($_POST['policy'][$i]['purpose'] as $purpose=>$yes) if($yes == 'YES')
    {
      $req = $_POST['policy'][$i]['purpose']["{$purpose}_required"];
      if($req == '') $req = 'always';
      $ret .= "        <$purpose required=\"{$req}\"/>\n";
    }
    $ret .= "      </PURPOSE>\n";

    $ret .= "      <RECIPIENT>\n";
    foreach($_POST['policy'][$i]['recipient'] as $recipient=>$yes) if($yes == 'YES')
    {
      $ret .= "        <$recipient><recipient-description>$recipient</recipient-description></$recipient>\n";
    }
    $ret .= "      </RECIPIENT>\n";
    $ret .= "      <RETENTION><{$_POST['policy'][$i]['retention']}/></RETENTION>\n";
    $ret .= "      <DATA-GROUP>\n";
    foreach($_POST['policy'][$i]['data'] as $key=>$value)
      $ret .= "        <DATA ref=\"#$key\"/>\n";
    $ret .= "      </DATA-GROUP>\n";
    $ret .= "    </STATEMENT>\n";
    $ret .= "  </POLICY>\n";
    $ret .= "</POLICIES>\n";
    return $ret;
  }

  function generate_human_policy_file($i)
  {
    global $purpose;

    $ret = "<html>\n";
    $ret .= "<head>\n";
    $ret .= "  <title>Privacy Policy for {$_POST['policy'][$i]['name']}</title>\n";
    $ret .= "</head>\n";
    $ret .= "<body>\n"; 
    $ret .= "<h1>Privacy Policy for {$_POST['policy'][$i]['name']}</h1>\n";
    $ret .= "<h2>Contacting Us</h2>\n";
    $ret .= "<p>{$_POST['policy'][$i]['organization']['name']}<br />\n";
    $ret .= "{$_POST['policy'][$i]['organization']['address']}<br />\n";
    $ret .= "{$_POST['policy'][$i]['organization']['city']}, {$_POST['policy'][$i]['organization']['stateprov']} {$_POST['policy'][$i]['organization']['postalcode']}<br />\n";
    $ret .= "{$_POST['policy'][$i]['organization']['telephone']}<br />\n";
    $ret .= "<a href=\"{$_POST['policy'][$i]['organization']['website']}\">{$_POST['policy'][$i]['organization']['website']}</a><br />\n";
    $ret .= "<a href=\"mailto:{$_POST['policy'][$i]['organization']['email']}\">{$_POST['policy'][$i]['organization']['email']}</a>\n";
    $ret .= "</p>\n";
    $ret .= "<h2>Dispute Resolution</h2>\n";
    $ret .= "<p>{$_POST['policy'][$i]['dispute']['description']}</p>\n";
    $ret .= "<p>Disputes will be handled by ";
    if($_POST['policy'][$i]['dispute']['resolution'] == 'service') $ret .= 'our customer service';
    if($_POST['policy'][$i]['dispute']['resolution'] == 'independent') $ret .= 'an independant organization';
    if($_POST['policy'][$i]['dispute']['resolution'] == 'court') $ret .= 'legal actions';
    if($_POST['policy'][$i]['dispute']['resolution'] == 'law') $ret .= 'applicable law';
    $ret .= " as outline at\n<a href=\"{$_POST['policy'][$i]['dispute']['url']}\">{$_POST['policy'][$i]['dispute']['url']}</a>.\n";
    if($_POST['policy'][$i]['dispute']['resolution'] == 'service') $ret .= 'Our customer service';
    if($_POST['policy'][$i]['dispute']['resolution'] == 'independent') $ret .= 'An independant organization';
    if($_POST['policy'][$i]['dispute']['resolution'] == 'court') $ret .= 'Legal actions';
    if($_POST['policy'][$i]['dispute']['resolution'] == 'law') $ret .= 'Applicable law';
    if($_POST['policy'][$i]['dispute']['remedy'] == 'correct') $ret .= ' will correct the errors.';
    if($_POST['policy'][$i]['dispute']['remedy'] == 'money') $ret .= ' will pay monitary damages.';
    if($_POST['policy'][$i]['dispute']['remedy'] == 'law') $ret .= ' will act as dictated by law.';
    $ret .= "</p>\n";
    $ret .= "<h2>Data Collection</h2>\n";
    $ret .= "<p>{$_POST['policy'][$i]['consequence']}</p>\n";
    $ret .= "<p>We collect the following information:</p>\n";
    $ret .= "<ul>\n";
    foreach($_POST['policy'][$i]['data'] as $key=>$value)
      $ret .= "  <li>$key</li>\n";
    $ret .= "</ul>\n";
    $ret .= "<p>We collect this data for the following reasons:</p>\n";
    $ret .= "<ul>\n";

    foreach($_POST['policy'][$i]['purpose'] as $key=>$yes) if($yes == 'YES')
    {
      $ret .= "  <li>{$purpose[$key]}</li>\n";
    }

    $ret .= "</ul>\n";
    $ret .= "<h2>Cookies</h2>\n";
    $ret .= "<p>Cookies are a technology which can be used to provide you with tailored information\n";
    $ret .= "from a Web site. A cookie is an element of data that a Web site can send to your\n";
    $ret .= "browser, which may then store it on your system. You can set your browser to notify\n";
    $ret .= "you when you receive a cookie, giving you the chance to decide whether to accept it.</p>\n";
    $ret .= "<p>Our site uses the following cookies:</p>\n";
    $ret .= "<ul>\n";
    $cookies = split("\n", $_POST['policy'][$i]['cookie_include']);
    for($j = 0; $j< sizeof($cookies); $j++)
    {
      $cookie = trim($cookies[$j]);
      if($cookie != "") $ret .= "  <li>$cookie</li>\n";
    }
    $ret .= "</ul>\n";
    $ret .= "</body>\n";
    $ret .= "<html>\n";
    return $ret;
  }

  function passalong($var = '', $stub = '')
  {
    echo spassalong($var, $stub);
  }

  function spassalong($var = '', $stub = '')
  {
    $ret = '';
    if($var == '' && $stub == '')  // pass along all post vars
    {
      foreach($_POST as $key=>$value)
        $ret .= spassalong($key);
    }
    else if($stub == '-') // pass a var along
    {
      reset($var);
      foreach($var as $key=>$val)
        $ret .= spassalong($val, $key);
    }
    else if($stub == '')  // pass along a specific post var
    {
      if(isset($_POST[$var]))
        $ret .= spassalong($_POST[$var], $var);
    }
    else
    {
      if(is_array($var)) // recursively process subarray
      {
        foreach($var as $key=>$val)
          $ret .= spassalong($val, $stub . "[$key]");
      }
      else
        $ret .= "<input type=\"hidden\" name=\"$stub\" value=\"$var\">\n";
    }
    return $ret;
  }

  function walk($base, $parent='', $i)
  {
    $indent = str_repeat(' ', substr_count($parent, ".") * 2);
    if(strpos($parent, "."))
    {
      echo "$indent<li><input type=\"checkbox\" name=\"policy[$i][data][$parent]\" value=\"YES\"";
      if($_POST['policy'][$i]['data'][$parent] == 'YES') echo ' checked="checked"';
      echo "/>{$base['description']}</li>\n";
    }
    if($parent != "") $parent .= ".";
    if(sizeof($base) > 1)
    {
      echo "$indent<ul>\n";
      while(list($key, $val) = each($base))
      {
        if($key != 'description' && $key != 'about') walk($val, $parent . $key, $i);
      }
      echo "$indent</ul>\n";
    }
  }
?>
