<?
  // step 1
  $reference_methods['well-known'] = '<b>Well know location:</b><br />This method simply places the reference file at <i>/w3c/p3p.xml</i>';
  $reference_methods['header'] = '<b>HTTP Headers:</b><br />This method adds an HTTP header in the form of<br /><i>P3P: policyref=&quot;http://mydomain.com/somedirectory/somefile.xml&quot;</i>';
  $reference_methods['link-tag'] = '<b>Link Tag:</b><br />This method adds a LINK tag to the HEAD section of the HTML document.<br /><i>&lt;link rel=&quot;P3Pv1&quot; href=&quot;http://mydomain.com/somedirectory/somefile.xml&quot; /&gt;</i>';

  // step 5
  $http_methods = array('OPTIONS'=>'OPTIONS','GET'=>'GET','HEAD'=>'HEAD','POST'=>'POST','PUT'=>'PUT','DELETE'=>'DELETE','TRACE'=>'TRACE','CONNECT'=>'CONNECT');

  // step 6
  $organization['name'] = 'Name';
  $organization['email'] = 'E-mail';
  $organization['website'] = 'Web Site';
  $organization['telephone'] = 'Telephone';
  $organization['address'] = 'Mailing Address';
  $organization['city'] = 'City';
  $organization['stateprov'] = 'State/Province';
  $organization['postalcode'] = 'Postal Code';

  // step 7
  $access['noident'] = 'Web site does not collect identified data.';
  $access['all'] = '<b>All Identified Data:</b> access is given to all identified data.';
  $access['contact-and-other'] = '<b>Identified Contact Information and Other Identified Data:</b> access is given to identified online and physical contact information as well as to certain other identified data.';
  $access['ident-contact'] = '<b>Identifiable Contact Information:</b> access is given to identified online and physical contact information (e.g., users can access things such as a postal address).';
  $access['other-ident'] = '<b>Other Identified Data:</b> access is given to certain other identified data (e.g., users can access things such as their online account charges).';
  $access['none'] = '<b>None:</b> no access to identified data is given.';

  // step 8
  $disputes['service'] = "<b>Customer Service:</b> Individual may complain to the Web site's customer service representative for resolution of disputes regarding the use of collected data. The description MUST include information about how to contact customer service.";
  $disputes['independent'] = '<b>Independent Organization:</b> Individual may complain to an independent organization for resolution of disputes regarding the use of collected data. The description MUST include information about how to contact the third party organization.';
  $disputes['court'] = '<b>Court:</b> Individual may file a legal complaint against the Web site.';
  $disputes['law'] = '<b>Applicable Law:</b> Disputes arising in connection with the privacy statement will be resolved in accordance with the law referenced in the description.';
  $remedies['correct'] = '<b>Errors will be corrected:</b> Errors or wrongful actions arising in connection with the privacy policy will be remedied by the service.';
  $remedies['money'] = '<b>Monetary damages will be paid:</b> If the service provider violates its privacy policy it will pay the individual an amount specified in the human readable privacy policy or the amount of damages.';
  $remedies['law'] = '<b>Governing law specifies remedies:</b> Remedies for breaches of the policy statement will be determined based on the law referenced in the human readable description.';

  // step 10
  $purpose['current'] = '<b>Completion and Support of Activity For Which Data Was Provided:</b> Information may be used by the service provider to complete the activity for which it was provided, whether a one-time activity such as returning the results from a Web search, forwarding an email message, or placing an order; or a recurring activity such as providing a subscription service, or allowing access to an online address book or electronic wallet.';
  $purpose['admin'] = '<b>Web Site and System Administration:</b> Information may be used for the technical support of the Web site and its computer system. This would include processing computer account information, information used in the course of securing and maintaining the site, and verification of Web site activity by the site or its agents.';
  $purpose['develop'] = '<b>Research and Development:</b> Information may be used to enhance, evaluate, or otherwise review the site, service, product, or market. This does not include personal information used to tailor or modify the content to the specific individual nor information used to evaluate, target, profile or contact the individual.';
  $purpose['tailoring'] = '<b>One-time Tailoring:</b> Information may be used to tailor or modify content or design of the site where the information is used only for a single visit to the site and not used for any kind of future customization. For example, an online store might suggest other items a visitor may wish to purchase based on the items he has already placed in his shopping basket.';
  $purpose['pseudo-analysis'] = '<b>Pseudonymous Analysis:</b> Information may be used to create or build a record of a particular individual or computer that is tied to a pseudonymous identifier, without tying identified data (such as name, address, phone number, or email address) to the record. This profile will be used to determine the habits, interests, or other characteristics of individuals for purpose of research, analysis and reporting, but it will not be used to attempt to identify specific individuals. For example, a marketer may wish to understand the interests of visitors to different portions of a Web site.';
  $purpose['pseudo-decision'] = '<b>Pseudonymous Decision:</b> Information may be used to create or build a record of a particular individual or computer that is tied to a pseudonymous identifier, without tying identified data (such as name, address, phone number, or email address) to the record. This profile will be used to determine the habits, interests, or other characteristics of individuals to make a decision that directly affects that individual, but it will not be used to attempt to identify specific individuals. For example, a marketer may tailor or modify content displayed to the browser based on pages viewed during previous visits.';
  $purpose['individual-analysis'] = '<b>Individual Analysis:</b> Information may be used to determine the habits, interests, or other characteristics of individuals and combine it with identified data for the purpose of research, analysis and reporting. For example, an online Web site for a physical store may wish to analyze how online shoppers make offline purchases.';
  $purpose['individual-decision'] = '<b>Individual Decision:</b> Information may be used to determine the habits, interests, or other characteristics of individuals and combine it with identified data to make a decision that directly affects that individual.  For example, an online store suggests items a visitor may wish to purchase based on items he has purchased during previous visits to the Web site.';
  $purpose['contact'] = '<b>Contacting Visitors for Marketing of Services or Products:</b> Information may be used to contact the individual, through a communications channel other than voice telephone, for the promotion of a product or service. This includes notifying visitors about updates to the Web site. This does not include a direct reply to a question or comment or customer service for a single transaction -- in those cases, <current/> would be used. In addition, this does not include marketing via customized Web content or banner advertisements embedded in sites the user is visiting -- these cases would be covered by the <tailoring/>, <pseudo-analysis/> and <pseudo-decision/>, or <individual-analysis/> and <individual-decision/> purposes.';
  $purpose['historical'] = '<b>Historical Preservation:</b> Information may be archived or stored for the purpose of preserving social history as governed by an existing law or policy. This law or policy MUST be referenced in the <DISPUTES> element and MUST include a specific definition of the type of qualified researcher who can access the information, where this information will be stored and specifically how this collection advances the preservation of history.';
  $purpose['telemarketing'] = '<b>Contacting Visitors for Marketing of Services or Products Via Telephone:</b> Information may be used to contact the individual via a voice telephone call for promotion of a product or service. This does not include a direct reply to a question or comment or customer service for a single transaction -- in those cases, <current/> would be used.';
  $purpose['other-purpose'] = '<b>Other Uses:</b> Information may be used in other ways not captured by the above definitions. (A human readable explanation MUST be provided in these instances).';

  $required['always'] = 'The purpose is always required; users cannot opt-in or opt-out of this use of their data. This is the default when no required attribute is present.';
  $required['opt-in'] = 'Data may be used for this purpose only when the user affirmatively requests this use -- for example, when a user asks to be added to a mailing list. An affirmative request requires users to take some action specifically to make the request. For example, when users fill out a survey, checking an additional box to request to be added to a mailing list would be considered an affirmative request. However, submitting a survey form that contains a pre-checked mailing list request box would not be considered an affirmative request. In addition, for any purpose that users may affirmatively request, there must also be a way for them to change their minds later and decline -- this MUST be specified at the opturi.';
  $required['opt-out'] = 'Data may be used for this purpose unless the user requests that it not be used in this way. When this value is selected, the service MUST provide clear instructions to users on how to opt-out of this purpose at the opturi. Services SHOULD also provide these instructions or a pointer to these instructions at the point of data collection.';

  // step 11
  $recipient['ours'] = '<b>Ourselves and/or entities acting as our agents or entities for whom we are acting as an agent:</b> An agent in this instance is defined as a third party that processes data only on behalf of the service provider for the completion of the stated purposes. (e.g., the service provider and its printing bureau which prints address labels and does nothing further with the information.)';
  $recipient['delivery'] = '<b>Delivery services possibly following different practices:</b> Legal entities performing delivery services that may use data for purposes other than completion of the stated purpose. This should also be used for delivery services whose data practices are unknown.';
  $recipient['same'] = '<b>Legal entities following our practices:</b> Legal entities who use the data on their own behalf under equable practices. (e.g., consider a service provider that grants the user access to collected personal information, and also provides it to a partner who uses it once but discards it. Since the recipient, who has otherwise similar practices, cannot grant the user access to information that it discarded, they are considered to have equable practices.)';
  $recipient['other-recipient'] = "<b>Legal entities following different practices:</b> Legal entities that are constrained by and accountable to the original service provider, but may use the data in a way not specified in the service provider's practices (e.g., the service provider collects data that is shared with a partner who may use it for other purposes. However, it is in the service provider's interest to ensure that the data is not used in a way that would be considered abusive to the users' and its own interests.)";
  $recipient['unrelated'] = '<b>Unrelated third parties:</b> Legal entities whose data usage practices are not known by the original service provider.';
  $recipient['public'] = '<b>Public fora:</b> Public fora such as bulletin boards, public directories, or commercial CD-ROM directories.';

  // step 12
  $retention['no-retention'] = '<b>No retention:</b> Information is not retained for more than a brief period of time necessary to make use of it during the course of a single online interaction. Information MUST be destroyed following this interaction and MUST NOT be logged, archived, or otherwise stored. This type of retention policy would apply, for example, to services that keep no Web server logs, set cookies only for use during a single session, or collect information to perform a search but do not keep logs of searches performed.';
  $retention['stated-purpose'] = "<b>For the stated purpose:</b> Information is retained to meet the stated purpose. This requires information to be discarded at the earliest time possible. Sites MUST have a retention policy that establishes a destruction time table. The retention policy MUST be included in or linked from the site's human-readable privacy policy.";
  $retention['legal-requirement'] = "<b>As required by law or liability under applicable law:</b> Information is retained to meet a stated purpose, but the retention period is longer because of a legal requirement or liability. For example, a law may allow consumers to dispute transactions for a certain time period; therefore a business may for liability reasons decide to maintain records of transactions, or a law may affirmatively require a certain business to maintain records for auditing or other soundness purposes. Sites MUST have a retention policy that establishes a destruction time table. The retention policy MUST be included in or linked from the site's human-readable privacy policy.";
  $retention['business-practices'] = "<b>Determined by service provider's business practice:</b> Information is retained under a service provider's stated business practices. Sites MUST have a retention policy that establishes a destruction time table. The retention policy MUST be included in or linked from the site's human-readable privacy policy.";
  $retention['indefinitely'] = '<b>Indefinitely:</b> Information is retained for an indeterminate period of time. The absence of a retention policy would be reflected under this option. Where the recipient is a public fora, this is the appropriate retention policy.';

  // step 13 - 16
  $reference["date"]["ymd"]["description"] = "Year/Month/Day";
  $reference["date"]["ymd"]["year"]["description"] = "Year";
  $reference["date"]["ymd"]["month"]["description"] = "Month";
  $reference["date"]["ymd"]["day"]["description"] = "Day";
  $reference["date"]["hms"]["description"] = "Hour/Minute/Second";
  $reference["date"]["hms"]["hour"]["description"] = "Hour";
  $reference["date"]["hms"]["minute"]["description"] = "Minute";
  $reference["date"]["hms"]["second"]["description"] = "Second";
  $reference["date"]["fractionsecond"]["description"] = "Fraction of Second";
  $reference["date"]["timezone"]["description"] = "Time Zone";
  $reference["personname"]["description"] = "Name";
  $reference["personname"]["prefix"]["description"] = "Name Prefix";
  $reference["personname"]["given"]["description"] = "Given Name (First Name)";
  $reference["personname"]["family"]["description"] = "Family Name (Last Name)";
  $reference["personname"]["middle"]["description"] = "Middle Name";
  $reference["personname"]["suffix"]["description"] = "Name Suffix";
  $reference["personname"]["nickname"]["description"] = "Nickname";
  $reference["login"]["description"] = "ID's and passwords";
  $reference["login"]["id"]["description"] = "Login ID";
  $reference["login"]["password"]["description"] = "Login Password";
  $reference["certificate"]["key"]["description"] = "Certificate key";
  $reference["certificate"]["format"]["description"] = "Certificate format";
  $reference["telephonenum"]["intcode"]["description"] = "International Telephone Code";
  $reference["telephonenum"]["loccode"]["description"] = "Local Telephone Area Code";
  $reference["telephonenum"]["number"]["description"] = "Telephone Number";
  $reference["telephonenum"]["ext"]["description"] = "Telephone Extension";
  $reference["telephonenum"]["comment"]["description"] = "Telephone Optional Comments";
  $reference["postal"]["name"] = $reference["personname"];
  $reference["postal"]["street"]["description"] = "Street Address";
  $reference["postal"]["city"]["description"] = "City";
  $reference["postal"]["stateprov"]["description"] = "State or Province";
  $reference["postal"]["postalcode"]["description"] = "Postal Code";
  $reference["postal"]["country"]["description"] = "Country Name";
  $reference["postal"]["organization"]["description"] = "Organization Name";
  $reference["telecom"]["telephone"] = $reference["telephonenum"];
  $reference["telecom"]["telephone"]["description"] = "Telephone Number";
  $reference["telecom"]["fax"] = $reference["telephonenum"];
  $reference["telecom"]["fax"]["description"] = "Fax Number";
  $reference["telecom"]["mobile"] = $reference["telephonenum"];
  $reference["telecom"]["mobile"]["description"] = "Mobile Telephone Number";
  $reference["telecom"]["pager"] = $reference["telephonenum"];
  $reference["telecom"]["pager"]["description"] = "Pager Number";
  $reference["online"]["email"]["description"] = "Email Address";
  $reference["online"]["uri"]["description"] = "Home Page Address";
  $reference["contact"]["postal"] = $reference["postal"];
  $reference["contact"]["postal"]["description"] = "Postal Address Information";
  $reference["contact"]["telecom"] = $reference["telecom"];
  $reference["contact"]["telecom"]["description"] = "Telecommunications Information";
  $reference["contact"]["online"] = $reference["online"];
  $reference["contact"]["online"]["description"] = "Online Address Information";
  $reference["uri"]["authority"]["description"] = "URI authority";
  $reference["uri"]["stem"]["description"] = "URI stem";
  $reference["uri"]["querystring"]["description"] = "Query-string portion of URI";
  $reference["ipaddr"]["hostname"]["description"] = "Complete host and domain name";
  $reference["ipaddr"]["partialhostname"]["description"] = "Partial hostname";
  $reference["ipaddr"]["fullip"]["description"] = "Full IP address";
  $reference["ipaddr"]["partialip"]["description"] = "Partial IP address";
  $reference["loginfo"]["uri"] = $reference["uri"];
  $reference["loginfo"]["uri"]["description"] = "URI of requested resource";
  $reference["loginfo"]["timestamp"] = $reference["date"];
  $reference["loginfo"]["timestamp"]["description"] = "Request timestamp";
  $reference["loginfo"]["clientip"] = $reference["ipaddr"];
  $reference["loginfo"]["clientip"]["description"] = "Client's IP address or hostname";
  $reference["loginfo"]["other"]["description"] ="Other log information";
  $reference["loginfo"]["other"]["httpmethod"]["description"] = "HTTP request method";
  $reference["loginfo"]["other"]["bytes"]["description"] = "Data bytes in response";
  $reference["loginfo"]["other"]["statuscode"]["description"] = "Response status code";
  $reference["httpinfo"]["referer"] = $reference["uri"];
  $reference["httpinfo"]["referer"]["description"] = "Last URI requested by the user";
  $reference["httpinfo"]["useragent"]["description"] = "User agent information";

  $base["description"] = "Data collection";

  $base["user"]["description"] = "User data collection";
  $base["user"]["name"] = $reference["personname"];
  $base["user"]["name"]["description"] = "User's Name";
  $base["user"]["bdate"] = $reference["date"];
  $base["user"]["bdate"]["description"] = "User's Birth Date";
  $base["user"]["login"] = $reference["login"];
  $base["user"]["login"]["description"] = "User's Login Information";
  $base["user"]["cert"] = $reference["cert"];
  $base["user"]["cert"]["description"] = "User's Identity Certificate";
  $base["user"]["gender"]["description"] = "User's Gender";
  $base["user"]["employer"]["description"] = "Name of User's Employer";
  $base["user"]["department"]["description"] = "Department or division of organization where user is employed";
  $base["user"]["jobtitle"]["description"] = "User's Job Title";
  $base["user"]["home-info"] = $reference["contact"];
  $base["user"]["home-info"]["description"] = "User's Home Contact Information";
  $base["user"]["business-info"] = $reference["contact"];
  $base["user"]["business-info"]["description"] = "User's Business Contact Information";

  $base["thirdparty"]["description"] = "Third Party data collection";
  $base["thirdparty"]["name"] = $reference["personname"];
  $base["thirdparty"]["name"]["description"] = "Third Party's Name";
  $base["thirdparty"]["bdate"] = $reference["date"];
  $base["thirdparty"]["bdate"]["description"] = "Third Party's Birth Date";
  $base["thirdparty"]["login"] = $reference["login"];
  $base["thirdparty"]["login"]["description"] = "Third Party's Login Information";
  $base["thirdparty"]["cert"] = $reference["cert"];
  $base["thirdparty"]["cert"]["description"] = "Third Party's Identity Certificate";
  $base["thirdparty"]["gender"]["description"] = "Third Party's Gender";
  $base["thirdparty"]["jobtitle"]["description"] = "Third Party's Job Title";
  $base["thirdparty"]["home-info"] = $reference["contact"];
  $base["thirdparty"]["home-info"]["description"] = "Third Party's Home Contact Information";
  $base["thirdparty"]["business-info"] = $reference["contact"];
  $base["thirdparty"]["business-info"]["description"] = "Third Party's Business Contact Information";
  $base["thirdparty"]["employer"]["description"] = "Name of Third Party's Employer";
  $base["thirdparty"]["department"]["description"] = "Department or division of organization where third party is employed";

  $base["business"]["description"] = "Business data collection";
  $base["business"]["name"]["description"] = "Organization Name";
  $base["business"]["department"]["description"] = "Department or division of organization";
  $base["business"]["cert"] = $reference["cert"];
  $base["business"]["cert"]["description"] = "Organization Identity certificate";
  $base["business"]["contact-info"] = $reference["contact"];
  $base["business"]["contact-info"]["description"] = "Contact Information for the Organization";

  $base["dynamic"]["description"] = "Dynamic data collection";
  $base["dynamic"]["clickstream"] = $reference["loginfo"];
  $base["dynamic"]["clickstream"]["description"] = "Click-stream information";
  $base["dynamic"]["clickstream"]["about"] = "The clickstream element is expected to apply to practically all Web sites. It represents the combination of information typically found in Web server access logs: the IP address or hostname of the user's computer, the URI of the resource requested, the time the request was made, the HTTP method used in the request, the size of the response, and the HTTP status code in the response. Web sites that collect standard server access logs as well as sites which do URI path analysis can use this data element to describe how that data will be used. Web sites that collect only some of the data elements listed for the clickstream element MAY choose to list those specific elements rather than the entire dynamic.clickstream element. This allows sites with more limited data-collection practices to accurately present those practices to their visitors.";
  $base["dynamic"]["http"] = $reference["httpinfo"];
  $base["dynamic"]["http"]["description"] = "HTTP protocol information";
  $base["dynamic"]["http"]["about"] = 'The http element contains additional information contained in the HTTP protocol. See the definition of the httpinfo structure for descriptions of specific elements. Sites MAY use the dynamic.http field as a shorthand to cover all the elements in the httpinfo structure if they wish, or they MAY reference the specific elements in the httpinfo structure.';
  $base["dynamic"]["clientevents"]["description"] = "User's interaction with a resource";
  $base["dynamic"]["clientevents"]["about"] = "The clientevents element represents data about how the user interacts with their Web browser while interacting with a resource. For example, an application may wish to collect information about whether the user moved their mouse over a certain image on a page, or whether the user ever brought up the help window in a Java applet. This kind of information is represented by the dynamic.clientevents data element. Much of this interaction record is represented by the events and data defined by the Document Object Model (DOM) Level 2 Events [DOM2-Events]. The clientevents data element also covers any other data regarding the user's interaction with their browser while the browser is displaying a resource. The exception is events which are covered by other elements in the base data schema. For example, requesting a page by clicking on a link is part of the user's interaction with their browser while viewing a page, but merely collecting the URL the user has clicked on does not require declaring this data element; clickstream covers that event. However, the DOM event DOMFocusIn (representing the user moving their mouse over an object on a page) is not covered by any other existing element, so if a site is collecting the occurrence of this event, then it needs to state that it collects the dynamic.clientevents element. Items covered by this data element are typically collected by client-side scripting languages, such as JavaScript, or by client-side applets, such as ActiveX or Java applets. Note that while the previous discussion has been in terms of a user viewing a resource, this data element also applies to Web applications which do not display resources visually - for example, audio-based Web browsers.";
//  $base["dynamic"]["cookies"]["description"] = "Use of HTTP cookies";
//  $base["dynamic"]["cookies"]["about"] = "The cookies element should be used whenever HTTP cookies are set or retrieved by a site. Please note that cookies is a variable data element and requires the explicit declaration of usage categories in a policy.";
//  $base["dynamic"]["miscdata"]["description"] = "Miscellaneous non-base data schema information";
//  $base["dynamic"]["miscdata"]["about"] = "The miscdata element references information collected by the service that the service does not reference using a specific data element. Categories have to be used to better describe these data: sites MUST reference a separate miscdata element in their policies for each category of miscellaneous data they collect.";
  $base["dynamic"]["searchtext"]["description"] = "Search terms";
  $base["dynamic"]["searchtext"]["about"] = "The searchtext element references a specific type of solicitation used for searching and indexing sites. For example, if the only fields on a search engine page are search fields, the site only needs to disclose that data element.";
  $base["dynamic"]["interactionrecord"]["description"] = "Server stores the transaction history";
  $base["dynamic"]["interactionrecord"]["about"] = "The interactionrecord element should be used if the server is keeping track of the interaction it has with the user (i.e. information other than clickstream data, for example account transactions, etc).";

  // step 17
  $category['physical'] = '<b>Physical Contact Information:</b> Information that allows an individual to be contacted or located in the physical world -- such as telephone number or address.';
  $category['online'] = '<b>Online Contact Information:</b> Information that allows an individual to be contacted or located on the Internet -- such as email. Often, this information is independent of the specific computer used to access the network. (See the category "Computer Information")';
  $category['uniqueid'] = '<b>Unique Identifiers:</b> Non-financial identifiers, excluding government-issued identifiers, issued for purposes of consistently identifying or recognizing the individual. These include identifiers issued by a Web site or service.';
  $category['purchase'] = '<b>Purchase Information:</b> Information actively generated by the purchase of a product or service, including information about the method of payment.';
  $category['financial'] = "<b>Financial Information:</b> Information about an individual's finances including account status and activity information such as account balance, payment or overdraft history, and information about an individual's purchase or use of financial instruments including credit or debit card information. Information about a discrete purchase by an individual, as described in \"Purchase Information,\" alone does not come under the definition of \"Financial Information.\"";
  $category['computer'] = '<b>Computer Information:</b> Information about the computer system that the individual is using to access the network -- such as the IP number, domain name, browser type or operating system.';
  $category['navigation'] = '<b>Navigation and Click-stream Data:</b> Data passively generated by browsing the Web site -- such as which pages are visited, and how long users stay on each page.';
  $category['interactive'] = '<b>Interactive Data:</b> Data actively generated from or reflecting explicit interactions with a service provider through its site -- such as queries to a search engine, or logs of account activity.';
  $category['demographic'] = "<b>Demographic and Socioeconomic Data:</b> Data about an individual's characteristics -- such as gender, age, and income.";
  $category['content'] = '<b>Content:</b> The words and expressions contained in the body of a communication -- such as the text of email, bulletin board postings, or chat room communications.';
  $category['state'] = '<b>State Management Mechanisms:</b> Mechanisms for maintaining a stateful session with a user or automatically recognizing users who have visited a particular site or accessed particular content previously -- such as HTTP cookies.';
  $category['political'] = '<b>Political Information:</b> Membership in or affiliation with groups such as religious organizations, trade unions, professional associations, political parties, etc.';
  $category['health'] = "<b>Health Information:</b> information about an individual's physical or mental health, sexual orientation, use or inquiry into health care services or products, and purchase of health care services or products.";
  $category['preference'] = "<b>Preference Data:</b> Data about an individual's likes and dislikes -- such as favorite color or musical tastes.";
  $category['location'] = "<b>Location Data:</b> Information that can be used to identify an individual's current physical location and track them as their location changes -- such as GPS position data.";
  $category['government'] = '<b>Government-issued Identifiers:</b> Identifiers issued by a government for purposes of consistently identifying the individual.';
  $category['other-category'] = '<b>Other:</b> Other types of data not captured by the above definitions. (A human readable explanation should be provided in these instances, between the <other-category> and the </other-category> tags.)';

  // generate
  $compact_tags = array('access'=>array('nonident'=>'NOI','all'=>'ALL','contact-and-other'=>'CAO','ident-contact'=>'IDC','other-ident'=>'OTI',
                            'none'=>'NON'),
                        'dispute'=>array('*'=>'DSP'),
                        'remedy'=>array('correct'=>'COR','money'=>'MON','law'=>'LAW'),
                        'non_identifiable'=>array('*'=>'NID'),
                        'purpose'=>array('current'=>'CUR','admin'=>'ADM','develop'=>'DEV','customization'=>'CUS','tailoring'=>'TAI',
                            'pseudo_analysis'=>'PSA','pseudo_decision'=>'PSD','individual_analysis'=>'IVA','individual_decision'=>'IVD',
                            'contact'=>'CON','historical'=>'HIS','telemarketing'=>'TEL','other-purpose'=>'OTP'),
                        'required'=>array('always'=>'a','opt-in'=>'i','opt-out'=>'o'),
                        'recipient'=>array('ours'=>'OUR','delivery'=>'DEL','same'=>'SAM','other_recipient'=>'OTR','unrelated'=>'UNR',
                            'public'=>'PUB','other-recipient'=>'OTR'),
                        'retention'=>array('no-retention'=>'NOR','state-purpose'=>'STP','legal-requirement'=>'LEG','business-practices'=>'BUS',
                            'indefinitely'=>'IND'),
                        'category'=>array('physical'=>'PHY','online'=>'ONL','uniqueid'=>'UNI','purchase'=>'PUR','financial'=>'FIN',
                            'computer'=>'COM','navigation'=>'NAV','interactive'=>'INT','demographic'=>'DEM','content'=>'CNT','state'=>'STA',
                            'political'=>'POL','health'=>'HEA','preference'=>'PRE','location'=>'LOC','government'=>'GOV','other-category'=>'OTC'));

?>
